using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication21
{
    class Program
    {
        static bool MozeNQ(int n, int q)
        {
            if (n <= 2 * Math.Pow(10, 5) && n >= 1 && q >= 1 && q <= Math.Pow(10, 5))
                return true;
            return false;
        }
        static bool MozePoz(int[,] poz, int n)
        {
            for (int i = 0; i < poz.GetLength(0); i++)
            {
                if (!(poz[i, 0] <= poz[i, 1]) || !(poz[i, 0] >= 0) || !(poz[i, 1] >= 0) || !(poz[i, 0] < n) || !(poz[i, 1] < n))
                    return false;
            }
            return true;
        }
        static bool MozeNiz(int n, int[] niz)
        {
            for (int i = 0; i < n; i++)
            {
                if (niz[i] > n)
                    return false;
            }
            return true;
        }
        static int BrojManjih(int[] niz, int l, int d, out int ind)
        {
            int br = 0;
            ind = -1;
            for (int i = l; i < d; i++)
            {
                if (niz[i] > niz[i + 1])
                    br++;
                if (br == 1)
                    ind = i;
            }
            return br;
        }
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            int[] niz = new int[n];
            string[] pom = Console.ReadLine().Split();
            for (int i = 0; i < n; i++)
            {
                niz[i] = int.Parse(pom[i]);
            }
            int q = int.Parse(Console.ReadLine());
            int[,] poz = new int[q, 2];
            for (int i = 0; i < q; i++)
            {
                string[] s = Console.ReadLine().Split();
                poz[i, 0] = int.Parse(s[0]) - 1;
                poz[i, 1] = int.Parse(s[1]) - 1;
            }

            if(MozeNQ(n, q) && MozePoz(poz, n) && MozeNiz(n, niz))
            {
                for (int i = 0; i < q; i++)
                {
                    int ind = -1;
                    int br = BrojManjih(niz, poz[i, 0], poz[i, 1], out ind);
                    if(br <= 1)
                        Console.WriteLine("DA");
                    else
                        Console.WriteLine("NE");
                }
            }
        }
    }
}